#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w 7
#include-once
; #INDEX# =======================================================================================================================
; Title .........: UDF to Decode Word Encoded with Quoted Printable
; AutoIt Version : 3.3.10.2++
; Language ......: English
; Description ...:
; Author(s) .....: Prog@ndy
; Modified ......: mLipok
; ===============================================================================================================================
#CS
	Author original post
	https://autoit.de/index.php/Thread/11350-UTF8-Sting-Convertieren/?postID=87721#post87721

	Quoted-Printable
	http://tools.ietf.org/html/rfc2045#section-6.7
	https://www.ietf.org/rfc/rfc2045.txt
#CE

;~ _QuotedPrintable_Example()

Func _QuotedPrintable_Example()
	Local $sTestString = ''
;~ https://autoit.de/index.php/Thread/11350-UTF8-Sting-Convertieren/?postID=87721#post87721
;~ $sTestString = "=?utf-8?b?QmFja3VwIEV4ZWMtTWVsZHVuZzogQXVmdHJhZyBlcmZvbGdyZWljaA==?="
	$sTestString = "=?iso-8859-2?Q?3%_na_Otwartym_Koncie_Oszcz=EAdno=B6ciowym?="
	MsgBox(0, '', _QuotedPrintable_DecodeEncodedWord($sTestString))
	MsgBox(0, '', _QuotedPrintable_DecodeEncodedWord("Subject: =?iso-8859-1?Q?=A1Hola,_se=F1or!?="))
EndFunc   ;==>_QuotedPrintable_Example

; #FUNCTION# ====================================================================================================================
; Name ..........: _QuotedPrintable_GetCodepage
; Description ...:
; Syntax ........: _QuotedPrintable_GetCodepage($charset)
; Parameters ....: $charset             - An unknown value.
; Return values .: None
; Author ........: Prog@ndy
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QuotedPrintable_GetCodepage($charset)
	Local Const $PATH = "HKEY_CLASSES_ROOT\MIME\Database\Charset\"
	Local $alias
	While 1
		$alias = RegRead($PATH & $charset, "AliasForCharset")
		If @error Then ExitLoop
		$charset = $alias
	WEnd
	Local $result = RegRead($PATH & $charset, "InternetEncoding")
	Return SetError(@error, @extended, $result)
EndFunc   ;==>_QuotedPrintable_GetCodepage

; #FUNCTION# ====================================================================================================================
; Name ..........: _QuotedPrintable_MultiByteToWideChar
; Description ...:
; Syntax ........: _QuotedPrintable_MultiByteToWideChar($CodePage, $dwFlags, $lpMultiByteStr, $cbMultiByte, $lpWideCharStr,
;                  $cchWideChar)
; Parameters ....: $CodePage            - An unknown value.
;                  $dwFlags             - An unknown value.
;                  $lpMultiByteStr      - An unknown value.
;                  $cbMultiByte         - An unknown value.
;                  $lpWideCharStr       - An unknown value.
;                  $cchWideChar         - An unknown value.
; Return values .: None
; Author ........: Prog@ndy
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QuotedPrintable_MultiByteToWideChar($CodePage, $dwFlags, $lpMultiByteStr, $cbMultiByte, $lpWideCharStr, $cchWideChar)
	Local $TypeMBStr = "str"
	If IsPtr($lpMultiByteStr) Then $TypeMBStr = "ptr"
	Local $aResult = DllCall("Kernel32.dll", "int", "MultiByteToWideChar", "UINT", $CodePage, "DWORD", $dwFlags, _
			$TypeMBStr, $lpMultiByteStr, "int", $cbMultiByte, "ptr", $lpWideCharStr, "int", $cchWideChar)
	If @error Then Return SetError(@error, 0, 0)
	Return $aResult[0]
EndFunc   ;==>_QuotedPrintable_MultiByteToWideChar

; #FUNCTION# ====================================================================================================================
; Name ..........: _QuotedPrintable_TranslateString
; Description ...:
; Syntax ........: _QuotedPrintable_TranslateString($String, $CodePage)
; Parameters ....: $String              - An unknown value.
;                  $CodePage            - An unknown value.
; Return values .: None
; Author ........: Prog@ndy
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QuotedPrintable_TranslateString($String, $CodePage)
	SetError(0)
	If Not (IsInt($CodePage) And $CodePage > 0) Then $CodePage = _QuotedPrintable_GetCodepage($CodePage)
	If @error Or $CodePage = 0 Then Return SetError(1, 0, "")
	Local $Length = _QuotedPrintable_MultiByteToWideChar($CodePage, 0, $String, StringLen($String), 0, 0)
	Local $Buffer = DllStructCreate("wchar[" & $Length + 1 & "]")
	If Not _QuotedPrintable_MultiByteToWideChar($CodePage, 0, $String, StringLen($String), DllStructGetPtr($Buffer), $Length) Then
		Return SetError(2, 0, "")
	EndIf
	Return DllStructGetData($Buffer, 1)
EndFunc   ;==>_QuotedPrintable_TranslateString

; #FUNCTION# ====================================================================================================================
; Name ..........: _QuotedPrintable_Base64Decode
; Description ...:
; Syntax ........: _QuotedPrintable_Base64Decode($s)
; Parameters ....: $s                   - A string value.
; Return values .: None
; Author ........: Eddy
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QuotedPrintable_Base64Decode($s)
	Local $key = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=', _
			$t = '', $p = -8, $a = 0, $c, $d, $len = StringLen($s)
	For $i = 1 To $len
		$c = StringInStr($key, StringMid($s, $i, 1), 1) - 1
		If $c < 0 Then ContinueLoop
		$a = BitOR(BitShift($a, -6), BitAND($c, 63))
		$p = $p + 6
		If $p >= 0 Then
			$d = BitAND(BitShift($a, $p), 255)
			If $c <> 64 Then $t = $t & Chr($d)
			$a = BitAND($a, 63)
			$p = $p - 8
		EndIf
	Next
	Return $t
EndFunc   ;==>_QuotedPrintable_Base64Decode

; #FUNCTION# ====================================================================================================================
; Name ..........: _QuotedPrintable_Decode
; Description ...:
; Syntax ........: _QuotedPrintable_Decode($s[, $IsQ = False])
; Parameters ....: $s                   - A string value.
;                  $IsQ                 - [optional] An unknown value. Default is False.
; Return values .: None
; Author ........: Prog@ndy
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QuotedPrintable_Decode($s, $IsQ = False)
	If $IsQ Then $s = StringReplace($s, "_", " ")
	$s = StringSplit($s, "=")
	Local $result = $s[1]
	For $i = 2 To $s[0]
		$result &= Chr(Dec(StringLeft($s[$i], 2))) & StringTrimLeft($s[$i], 2)
	Next
	Return $result
EndFunc   ;==>_QuotedPrintable_Decode

; #FUNCTION# ====================================================================================================================
; Name ..........: _QuotedPrintable_DecodeEncodedWord
; Description ...:
; Syntax ........: _QuotedPrintable_DecodeEncodedWord($theString)
; Parameters ....: $theString           - A dll struct value.
; Return values .: None
; Author ........: Prog@ndy
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QuotedPrintable_DecodeEncodedWord($theString)
	Local $EncodedChunks = StringRegExp($theString, "=\?(.+?)\?(.)\?(.*?)\?=", 4)
	If Not @error Then
		Local $parts
		For $Index = 0 To UBound($EncodedChunks) - 1
			$parts = $EncodedChunks[$Index]
			Switch $parts[2]
				Case "B", "b"
					$parts[3] = _QuotedPrintable_Base64Decode($parts[3])
				Case "Q", "q"
					$parts[3] = _QuotedPrintable_Decode($parts[3], True)
			EndSwitch
			$parts[3] = _QuotedPrintable_TranslateString($parts[3], $parts[1])
			$theString = StringReplace($theString, $parts[0], $parts[3])
		Next
	EndIf
	Return $theString
EndFunc   ;==>_QuotedPrintable_DecodeEncodedWord
